| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::OverlayManager Class Reference
Optional Components » Overlay

Manages Overlay objects, parsing them from .overlay files and storing a lookup library of them. More...

`#include <OgreOverlayManager.h>`

Inheritance diagram for Ogre::OverlayManager:
[legend]

## Public Types
typedef std::map< String, OverlayElement * > | ElementMap
typedef std::map< String, OverlayElementFactory * > | FactoryMap
typedef std::map< String, Overlay * > | OverlayMap
typedef MapIterator< OverlayMap > | OverlayMapIterator
typedef MapIterator< ElementMap > | TemplateIterator

## Public Member Functions
| OverlayManager ()
virtual | ~OverlayManager ()
void | _queueOverlaysForRendering (Camera *cam, RenderQueue *pQueue, Viewport *vp)
| Internal method for queueing the visible overlays for rendering. More...
void | _releaseManualHardwareResources ()
| Notifies that hardware resources were lost. More...
void | _restoreManualHardwareResources ()
| Notifies that hardware resources should be restored. More...
void | addOverlayElementFactory (OverlayElementFactory *elemFactory)
| Registers a new OverlayElementFactory with this manager. More...
OverlayElement * | cloneOverlayElementFromTemplate (const String &templateName, const String &instanceName)
Overlay * | create (const String &name)
| Create a new Overlay. More...
OverlayElement * | createOverlayElement (const String &typeName, const String &instanceName, bool isTemplate=false)
| Creates a new OverlayElement of the type requested. More...
OverlayElement * | createOverlayElementFromFactory (const String &typeName, const String &instanceName)
OverlayElement * | createOverlayElementFromTemplate (const String &templateName, const String &typeName, const String &instanceName, bool isTemplate=false)
void | destroy (const String &name)
| Destroys an existing overlay by name. More...
void | destroy (Overlay *overlay)
| Destroys an existing overlay. More...
void | destroyAll (void)
| Destroys all existing overlays. More...
void | destroyAllOverlayElements (bool isTemplate=false)
| Destroys all the OverlayElement created so far. More...
void | destroyOverlayElement (const String &instanceName, bool isTemplate=false)
| Destroys a OverlayElement. More...
void | destroyOverlayElement (OverlayElement *pInstance, bool isTemplate=false)
| Destroys a OverlayElement. More...
Overlay * | getByName (const String &name)
| Retrieve an Overlay by name. More...
Real | getLoadingOrder (void) const
| Gets the relative loading order of scripts of this type. More...
OverlayElement * | getOverlayElement (const String &name, bool isTemplate=false)
| Gets a reference to an existing element. More...
const FactoryMap & | getOverlayElementFactoryMap () const
| Get const access to the list of registered OverlayElement factories. More...
OverlayMapIterator | getOverlayIterator (void)
const StringVector & | getScriptPatterns (void) const
| Gets the file patterns which should be used to find scripts for this class. More...
TemplateIterator | getTemplateIterator ()
| Returns an iterator over all templates in this manager. More...
Real | getViewportAspectRatio (void) const
int | getViewportHeight (void) const
| Gets the height of the destination viewport in pixels. More...
OrientationMode | getViewportOrientationMode (void) const
| Gets the orientation mode of the destination viewport. More...
int | getViewportWidth (void) const
| Gets the width of the destination viewport in pixels. More...
bool | hasOverlayElement (const String &name, bool isTemplate=false)
| Tests if an element exists. More...
bool | isTemplate (String strName) const
void | parseScript (DataStreamPtr &stream, const String &groupName)
| Parse a script file. More...

## Static Public Member Functions
static OverlayManager & | getSingleton (void)
| Override standard Singleton retrieval. More...
static OverlayManager * | getSingletonPtr (void)
| Get the singleton instance. More...

## Detailed Description

Manages Overlay objects, parsing them from .overlay files and storing a lookup library of them.

Also manages the creation of OverlayContainers and OverlayElements, used for non-interactive 2D elements such as HUDs.

## Member Typedef Documentation

## ◆ OverlayMap

typedef std::map<String, Overlay*> Ogre::OverlayManager::OverlayMap

## ◆ ElementMap

typedef std::map<String, OverlayElement*> Ogre::OverlayManager::ElementMap

## ◆ FactoryMap

typedef std::map<String, OverlayElementFactory*> Ogre::OverlayManager::FactoryMap

## ◆ OverlayMapIterator

typedef MapIterator<OverlayMap> Ogre::OverlayManager::OverlayMapIterator

## ◆ TemplateIterator

typedef MapIterator<ElementMap> Ogre::OverlayManager::TemplateIterator

## Constructor & Destructor Documentation

## ◆ OverlayManager()

Ogre::OverlayManager::OverlayManager | ( |  | ) |

## ◆ ~OverlayManager()

virtual Ogre::OverlayManager::~OverlayManager | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _releaseManualHardwareResources()

void Ogre::OverlayManager::_releaseManualHardwareResources | ( |  | ) |

Notifies that hardware resources were lost.

## ◆ _restoreManualHardwareResources()

void Ogre::OverlayManager::_restoreManualHardwareResources | ( |  | ) |

Notifies that hardware resources should be restored.

## ◆ getScriptPatterns()

const StringVector& Ogre::OverlayManager::getScriptPatterns | ( | void |  | ) | const
| virtual

Gets the file patterns which should be used to find scripts for this class.

Remarks
  This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader.

Returns
  A list of file patterns, in the order they should be searched in.

Implements Ogre::ScriptLoader.

## ◆ parseScript()

void Ogre::OverlayManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName
| ) |  |
| virtual

Parse a script file.

Parameters

  stream | Weak reference to a data stream which is the source of the script
  groupName | The name of a resource group which should be used if any resources are created during the parse of this script.

Implements Ogre::ScriptLoader.

## ◆ getLoadingOrder()

Real Ogre::OverlayManager::getLoadingOrder | ( | void |  | ) | const
| virtual

Gets the relative loading order of scripts of this type.

Remarks
  There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order.

Returns
  A value representing the relative loading order of these scripts compared to other script users, where higher values load later.

Implements Ogre::ScriptLoader.

## ◆ create()

Overlay* Ogre::OverlayManager::create | ( | const String & | name | ) |

Create a new Overlay.

## ◆ getByName()

Overlay* Ogre::OverlayManager::getByName | ( | const String & | name | ) |

Retrieve an Overlay by name.

Returns
  A pointer to the Overlay, or 0 if not found

## ◆ destroy() [1/2]

void Ogre::OverlayManager::destroy | ( | const String & | name | ) |

Destroys an existing overlay by name.

## ◆ destroy() [2/2]

void Ogre::OverlayManager::destroy | ( | Overlay * | overlay | ) |

Destroys an existing overlay.

## ◆ destroyAll()

void Ogre::OverlayManager::destroyAll | ( | void |  | ) |

Destroys all existing overlays.

## ◆ getOverlayIterator()

OverlayMapIterator Ogre::OverlayManager::getOverlayIterator | ( | void |  | ) |

## ◆ _queueOverlaysForRendering()

void Ogre::OverlayManager::_queueOverlaysForRendering | ( | Camera * | cam,
|  | RenderQueue * | pQueue,
|  | Viewport * | vp
| ) |  |

Internal method for queueing the visible overlays for rendering.

## ◆ getViewportHeight()

int Ogre::OverlayManager::getViewportHeight | ( | void |  | ) | const

Gets the height of the destination viewport in pixels.

## ◆ getViewportWidth()

int Ogre::OverlayManager::getViewportWidth | ( | void |  | ) | const

Gets the width of the destination viewport in pixels.

## ◆ getViewportAspectRatio()

Real Ogre::OverlayManager::getViewportAspectRatio | ( | void |  | ) | const

## ◆ getViewportOrientationMode()

OrientationMode Ogre::OverlayManager::getViewportOrientationMode | ( | void |  | ) | const

Gets the orientation mode of the destination viewport.

## ◆ createOverlayElement()

OverlayElement* Ogre::OverlayManager::createOverlayElement | ( | const String & | typeName,
|  | const String & | instanceName,
|  | bool | isTemplate = `false`
| ) |  |

Creates a new OverlayElement of the type requested.

Remarks
  The type of element to create is passed in as a string because this allows plugins to register new types of component.

Parameters

  typeName | The type of element to create.
  instanceName | The name to give the new instance.

## ◆ getOverlayElement()

OverlayElement* Ogre::OverlayManager::getOverlayElement | ( | const String & | name,
|  | bool | isTemplate = `false`
| ) |  |

Gets a reference to an existing element.

## ◆ hasOverlayElement()

bool Ogre::OverlayManager::hasOverlayElement | ( | const String & | name,
|  | bool | isTemplate = `false`
| ) |  |

Tests if an element exists.

## ◆ destroyOverlayElement() [1/2]

void Ogre::OverlayManager::destroyOverlayElement | ( | const String & | instanceName,
|  | bool | isTemplate = `false`
| ) |  |

Destroys a OverlayElement.

Remarks
  Make sure you're not still using this in an Overlay. If in doubt, let OGRE destroy elements on shutdown.

## ◆ destroyOverlayElement() [2/2]

void Ogre::OverlayManager::destroyOverlayElement | ( | OverlayElement * | pInstance,
|  | bool | isTemplate = `false`
| ) |  |

Destroys a OverlayElement.

Remarks
  Make sure you're not still using this in an Overlay. If in doubt, let OGRE destroy elements on shutdown.

## ◆ destroyAllOverlayElements()

void Ogre::OverlayManager::destroyAllOverlayElements | ( | bool | isTemplate = `false` | ) |

Destroys all the OverlayElement created so far.

Remarks
  Best to leave this to the engine to call internally, there should rarely be a need to call it yourself.

## ◆ addOverlayElementFactory()

void Ogre::OverlayManager::addOverlayElementFactory | ( | OverlayElementFactory * | elemFactory | ) |

Registers a new OverlayElementFactory with this manager.

Remarks
  Should be used by plugins or other apps wishing to provide a new OverlayElement subclass.

## ◆ getOverlayElementFactoryMap()

const FactoryMap& Ogre::OverlayManager::getOverlayElementFactoryMap | ( |  | ) | const
| inline

Get const access to the list of registered OverlayElement factories.

## ◆ createOverlayElementFromTemplate()

OverlayElement* Ogre::OverlayManager::createOverlayElementFromTemplate | ( | const String & | templateName,
|  | const String & | typeName,
|  | const String & | instanceName,
|  | bool | isTemplate = `false`
| ) |  |

## ◆ cloneOverlayElementFromTemplate()

OverlayElement* Ogre::OverlayManager::cloneOverlayElementFromTemplate | ( | const String & | templateName,
|  | const String & | instanceName
| ) |  |

Remarks
  Creates a new OverlayElement object from the specified template name. The new object's name, and all of it's children, will be instanceName/orignalName.

## ◆ createOverlayElementFromFactory()

OverlayElement* Ogre::OverlayManager::createOverlayElementFromFactory | ( | const String & | typeName,
|  | const String & | instanceName
| ) |  |

## ◆ getTemplateIterator()

TemplateIterator Ogre::OverlayManager::getTemplateIterator | ( |  | ) |
| inline

Returns an iterator over all templates in this manager.

## ◆ isTemplate()

bool Ogre::OverlayManager::isTemplate | ( | String | strName | ) | const
| inline

## ◆ getSingleton()

static OverlayManager& Ogre::OverlayManager::getSingleton | ( | void |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static OverlayManager* Ogre::OverlayManager::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

The documentation for this class was generated from the following file:

- OgreOverlayManager.h